class WkexpenseController < WktimeController
  unloadable  
  
  include WkexpenseHelper
  
  def getLabelforSpField
	l(:field_amount)
  end
  
  def getCFInRowHeaderHTML
    "wkexpense_cf_in_row_header"
  end
  
  def getCFInRowHTML
    "wkexpense_cf_in_row"
  end
  
  def getTFSettingName
	"wkexpense_issues_filter_tracker"
  end
  
  def filterTrackerVisible
	false
  end
  
  def getUnit(entry)
	entry.nil? ? l('number.currency.format.unit') : entry[:currency]
  end
  
  def getUnitDDHTML
	"wkexpense_currency"
  end
  
  def getUnitLabel
	l(:label_wk_currency)
  end
  
  def showWorktimeHeader
	false
  end 
  
  def maxHour
	0
  end
  
  def total_all(total)
	total.nil? ? html_hours("%.2f" % 0.00) : html_hours("%.2f" % total)
  end
 
private
  def getSpecificField
	"amount"
  end

  def getEntityNames
	["#{Wkexpense.table_name}", "#{WkExpenseEntry.table_name}"]
  end
  
  def findBySql(selectStr,sqlStr,wkSelectStr,wkSqlStr)
	spField = getSpecificField()
	result = WkExpenseEntry.find_by_sql("select count(*) as id from (" + selectStr + sqlStr + ") as v2")
	@entry_count = result[0].id
	@entry_pages = Paginator.new self, @entry_count, per_page_option, params['page']	
		
	@entries = WkExpenseEntry.find_by_sql(wkSelectStr + " ,exp.currency" + sqlStr + 
		" inner join wk_expense_entries exp on v1.id = exp.id " + wkSqlStr +
		" LIMIT " + @entry_pages.items_per_page.to_s +
		" OFFSET " + @entry_pages.current.offset.to_s)
	@unit = @entries.blank? ? l('number.currency.format.unit') : @entries[0][:currency]
	
	#@total_hours = TimeEntry.visible.sum(:hours, :include => [:user], :conditions => cond.conditions).to_f
		
	result = WkExpenseEntry.find_by_sql("select sum(v2." + spField + ") as " + spField + " from (" + selectStr + sqlStr + ") as v2")	
	@total_hours = result[0].amount
  end
  
  def findWkTEByCond(cond)
	@wktimes = Wkexpense.find(:all, :conditions => cond)
  end
  
  def findEntriesByCond(cond)
	WkExpenseEntry.find(:all, :conditions => cond,
		:order => 'project_id, issue_id, activity_id, spent_on')
  end
  
  def setValueForSpField(timeEntry,spValue,decimal_separator,entry)
	timeEntry.amount = spValue.blank? ? nil : spValue.gsub(decimal_separator, '.').to_f	
	timeEntry.currency = getUnit(entry)  	
  end
  
  def getNewCustomField
	nil
  end
  
  def getWkEntity
	Wkexpense.new 
  end
  
  def getTEEntry(id)
	id.blank? ? WkExpenseEntry.new : WkExpenseEntry.find(id)
  end
  
  def deleteWkEntity(cond) 
	Wkexpense.delete_all(cond)
  end 
  
  def delete(ids)
	WkExpenseEntry.delete(ids)
  end
  
  def findTEEntries(ids)
	WkExpenseEntry.find(ids)
  end
  
  def setTotal(wkEntity,total)
	wkEntity.amount = total
  end
  
  def setEntityLabel
	l(:label_wkexpense)
  end
end
