class WkExpenseEntry < TimeEntry
  unloadable
  
  set_table_name "wk_expense_entries"
  
  validates_numericality_of :amount, :message => :invalid
  
  #hours function of TimeEntry(base class) is overrided to use amount column of WkExpenseEntry
  
  def validate_time_entry
    errors.add :amount, :invalid if amount && (amount < 0 || amount >= 100000)
    errors.add :project_id, :invalid if project.nil?
    errors.add :issue_id, :invalid if (issue_id && !issue) || (issue && project!=issue.project)
  end  
  
  def hours=(h)
    write_attribute :amount, (h.is_a?(String) ? (h.to_i || h) : h)
  end

  def hours
    h = read_attribute(:amount)
    if h.is_a?(Float)
      h.round(2)
    else
      h
    end
  end
end
